#include <cuex/binding.h>
#include <cuex/var.h>
#include <cuex/oprdefs.h>
#include <cucon/pmap.h>

cu_clop_def(show_indexing_cb, void, void const *e, void *slot)
{
    cu_fprintf(stdout, "    %d: %!\n", *(int *)slot, e);
}

void test(cuex_t e)
{
    cucon_pmap_t indexing = cuex_bi_sifi_indexing(e, CUEX_BI_SIFI_FLAG_PRUNE);
    cucon_pmap_iter_mem(indexing, show_indexing_cb);
}

#define lam cuex_o1_lambda
#define mu cuex_o1_mu
#define apply cuex_o2_apply
#define gprod cuex_o2_gprod
#define sgt cuex_o1_singleton
#define hole cuex_hole

int main()
{
    cuex_t e1, e2, e3;

    cuex_init();
    e1 = cuex_var_new_e();
    e2 = cuex_var_new_e();
    e3 = cuex_var_new_e();

    fputs("----\n", stdout);
    test(cuex_o1_lambda(cuex_o2_apply(cuex_o1_lambda(hole(1)), hole(0))));
    fputs("----\n", stdout);
    test(cuex_o1_lambda(cuex_o2_apply(cuex_o1_lambda(hole(0)), hole(0))));
    fputs("----\n", stdout);
    test(cuex_o1_lambda(cuex_o1_lambda(cuex_o1_lambda(hole(2)))));

    fputs("----\n", stdout);
    test(cuex_o1_lambda(cuex_o1_lambda(cuex_o2_apply(hole(1), hole(0)))));

    fputs("====\n", stdout);
    test(lam(mu(gprod(lam(hole(1)), mu(sgt(hole(2)))))));
    fputs("----\n", stdout);
    test(mu(lam(gprod(hole(1), sgt(hole(0))))));
    fputs("----\n", stdout);
    test(lam(mu(gprod(cuex_o1_lambda(hole(1)), hole(1)))));
    fputs("----\n", stdout);
    test(mu(lam(gprod(hole(1), hole(0)))));

    fputs("====\n", stdout);
    test(gprod(gprod(mu(gprod(hole(0),
			      lam(hole(0)))),
		     lam(hole(0))),
	       lam(hole(0))));

    fputs("====\n", stdout);
    test(lam(gprod(lam(hole(1)),
		      gprod(lam(gprod(mu(gprod(e1, hole(2))), hole(0))),
			    e2))));
    fputs("----\n", stdout);
    test(lam(gprod(lam(hole(1)),
		      gprod(lam(gprod(gprod(e1, hole(1)), hole(0))),
			    e2))));
    fputs("====\n", stdout);
    test(mu(gprod(lam(mu(gprod(hole(1),
			       lam(lam(gprod(hole(2),
					     sgt(hole(0)))))))),
		  hole(0))));
    fputs("----\n", stdout);
    test(gprod(lam(mu(gprod(hole(1),
			    lam(lam(gprod(hole(2),
					  sgt(hole(0)))))))),
	       mu(gprod(lam(mu(gprod(hole(1),
				     lam(lam(gprod(hole(2),
						   sgt(hole(0)))))))),
			hole(0)))));
    fputs("====\n", stdout);
    test(mu(gprod(gprod(sgt(lam(gprod(mu(gprod(lam(gprod(hole(1), hole(0))), hole(1))), hole(1)))), gprod(e1, e2)), e3)));
    fputs("----\n", stdout);
    test(gprod(gprod(sgt(lam(gprod(mu(gprod(lam(gprod(hole(1), hole(0))), hole(1))), mu(gprod(gprod(sgt(lam(gprod(mu(gprod(lam(gprod(hole(1), hole(0))), hole(1))), hole(1)))), gprod(e1, e2)), e3))))), gprod(e1, e2)), e3));
    fputs("----\n", stdout);
    test(gprod(gprod(sgt(lam(gprod(gprod(lam(gprod(mu(gprod(lam(gprod(hole(1), hole(0))), hole(2))), hole(0))), hole(0)), gprod(gprod(sgt(lam(gprod(mu(gprod(lam(gprod(hole(1), hole(0))), hole(1))), mu(gprod(gprod(sgt(lam(gprod(mu(gprod(lam(gprod(hole(1), hole(0))), hole(1))), hole(1)))), gprod(e1, e2)), e3))))), gprod(e1, e2)), e3)))), gprod(e1, e2)), e3));
    return 0;
}
